package edu.msoe.se1021.studentinfo.YOURNAME;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.BevelBorder;

@SuppressWarnings("serial")
public class StudentInformationUI extends JFrame {

	private JPanel jpName;    // The main panel used to contain components for the Name entry form
	private JPanel jpAddress; // The main panel used to contain components for the Address entry form
	private JPanel jpMajor;   // The main panel used to contain components for the Major entry form

	// These constants indicate the currently active panel
	private static final int NAME_PANEL=1;
	private static final int ADDRESS_PANEL=2;
	private static final int MAJOR_PANEL=3;
	private int activePanel; // this attribute tracks the currently active panel

	private JTextField tfLastname; // the text field used to input the student's last name
	private JTextField tfFirstname; // first name
	private JTextField tfMI; // middle initial
	private JTextField tfStreet; // street address
	private JTextField tfApt; // apartment number
	private JTextField tfCity; // city
	private JTextField tfState; // state
	private JTextField tfZip; // zip code
	private JTextField tfDept; // Major department
	private JTextField tfProgram; // Major program
	private JTextField tfYear; // expected year of graduation

	private ActionListener bh; // reference to a class that implements ActionListener

	public StudentInformationUI() {
		//TODO: initialize an instance of the private inner ButtonHandler here
	}

	/*
	 * create the UI and display the first "page"
	 */
	public void initUI() {
		setTitle("Student information Entry");
		setBounds(100,100, 500, 500); // location and size
		setResizable(false); // prevent resizing

		Container canvas = getContentPane();
		// TODO: Make the canvas use absolution positioning for the JPanel "pages" to be placed on it.
		// We need to avoid using a layout manager so that the "pages" can overlap

	
		jpName = createNameForm();	// create the Name "page"
		jpAddress = createAddressForm(); // create the Address "page"
		jpMajor = createMajorForm();	// create the Major "page"

		// TODO: show this JFrame,
		// make the first "page" visible,
		// remember which "page" (i.e. panel) is active
	}

	/**
	 * This method creates a JPanel containing the components that make up the name entry form.
	 * Note that the JPanel is not made visible in this method.
	 * @return a reference to the JPanel created and added to the Container of this UI's JFrame
	 */
	public JPanel createNameForm() {
		Dimension std = new Dimension(200,25); // a standard size to use for JLabels and JTextfields

		// TODO: Create the main JPanel with a BorderLayout. This is the only
		// component in this "page" contained directly on the canvas. This entire panel
		// constitutes the "name page" of the input form and is made visible 
		// or invisible to show/hide the page.
		
		// TODO: Set the size of the Name panel to be 450 x 350.
		// Use a border layout for the panel.
		// Make it invisible initially.
		// Put a title on the JPanel's border

		// TODO: Create another JPanel with a 3x1 GridLayout. This panel is put in the 
		// center of the BorderLayout of the main JPanel

		// TODO: Create three JPanels each with a FlowLayout. These panels are
		// put in the three cells of the grid of the panel in the center of the 
		// BorderLayout of the main panel. Each of these three panels contains
		// a JLabel and a JTextField for the name input components.

		// TODO: Create a JPanel with a centered Flowlayout. This panel is put in the 
		// south cell of the BorderLayout of the main JPanel. This panel contains the 
		// "Next" button that, when pressed, causes this entire page to become
		// invisible and the Address page to become visible.

		// TODO: return a reference to the main panel of this page.
		return null;

	}

	/**
	 * This method creates a JPanel containing the components that make up the address entry form.
	 * Note that the JPanel is not made visible in this method.
	 * @return a reference to the JPanel created and added to the Container of this UI's JFrame
	 */
	public JPanel createAddressForm() {
		Dimension std = new Dimension(200,25); // a standard size to use for JLabels and JTextfields

		// TODO: Create the main JPanel with a BorderLayout. This is the only
		// component in this "page" contained directly on the canvas. This entire panel
		// constitutes the "address page" of the input form and is made visible 
		// or invisible to show/hide the page.
		
		// TODO: Set the size of the Name panel to be 450 x 350.
		// Use a border layout for the panel.
		// Make it invisible initially.
		// Put a title on the JPanel's border

		// TODO: Create another JPanel with a 5x1 GridLayout. This panel is put in the 
		// center of the BorderLayout of the main JPanel

		// TODO: Create five JPanels each with a FlowLayout. These panels are
		// put in the five cells of the grid of the panel in the center of the 
		// BorderLayout of the main panel. Each of these five panels contains
		// a JLabel and a JTextField for the address input components.

		// TODO: Create a JPanel with a centered Flowlayout. This panel is put in the 
		// south cell of the BorderLayout of the main JPanel. This panel contains the 
		// "Next" and "Prev" buttons that, when pressed, causes this entire page to become
		// invisible and the Name or Major pages to become visible.

		// TODO: return a reference to the main panel of this page.
		return null;

	}

	/**
	 * This method creates a JPanel containing the components that make up the major entry form.
	 * Note that the JPanel is not made visible in this method.
	 * @return a reference to the JPanel created and added to the Container of this UI's JFrame
	 */
	public JPanel createMajorForm() {
		Dimension std = new Dimension(200,25); // a standard size to use for JLabels and JTextfields

		// TODO: Create the main JPanel with a BorderLayout. This is the only
		// component in this "page" contained directly on the canvas. This entire panel
		// constitutes the "Major page" of the input form and is made visible 
		// or invisible to show/hide the page.
		
		// TODO: Set the size of the Name panel to be 450 x 350.
		// Use a border layout for the panel.
		// Make it invisible initially.
		// Put a title on the JPanel's border

		// TODO: Create another JPanel with a 3x1 GridLayout. This panel is put in the 
		// center of the BorderLayout of the main JPanel

		// TODO: Create three JPanels each with a FlowLayout. These panels are
		// put in the three cells of the grid of the panel in the center of the 
		// BorderLayout of the main panel. Each of these three panels contains
		// a JLabel and a JTextField for the name input components.

		// TODO: Create a JPanel with a centered Flowlayout. This panel is put in the 
		// south cell of the BorderLayout of the main JPanel. This panel contains the 
		// "Prev" and "Finish" buttons that, when pressed, causes this entire page to become
		// invisible and the Address or final pages to become visible.

		// TODO: return a reference to the main panel of this page.
		return null;
	}

	// TODO: Create a private nested class to handle pushbutton events

	// TODO: within the event-handling logic, determine:
	// 1) which of the panels is currently active,
	// 2) whether all of the text input fields on that panel has been filled out,
	//      (if not, print an error message reminding the user to completely fill out the form)
	// 2) which pushbutton (for that particular panel) was pressed,
	// 3) which panel to show after this one is hidden,
	//      (if the "Final" button is pressed, gather all information and present it in a 
	///     JOptionPane message dialog. Quit after dismissing the summary).
}
